package eu.mhsl.craftattack.spawn.appliances.autoShulker;

import eu.mhsl.craftattack.spawn.appliances.settings.CategorizedSetting;
import eu.mhsl.craftattack.spawn.appliances.settings.SettingCategory;
import eu.mhsl.craftattack.spawn.appliances.settings.Settings;
import eu.mhsl.craftattack.spawn.appliances.settings.datatypes.SelectSetting;
import org.bukkit.Material;
import org.bukkit.NamespacedKey;

import java.util.List;
import java.util.Locale;

public class AutoShulkerSetting extends SelectSetting implements CategorizedSetting {
    private static final String namespace = AutoShulkerSetting.class.getSimpleName().toLowerCase(Locale.ROOT);
    public static Options.Option disabled = new Options.Option("Deaktiviert", new NamespacedKey(namespace, "disabled"));
    public static Options.Option notFromPlayers = new Options.Option("Keine manuell gedroppten Items", new NamespacedKey(namespace, "noplayerdrops"));
    public static Options.Option enabled = new Options.Option("Alle", new NamespacedKey(namespace, "enabled"));

    public AutoShulkerSetting() {
        super(
            Settings.Key.AutoShulker,
            new Options(List.of(disabled, notFromPlayers, enabled))
        );
    }

    @Override
    protected String title() {
        return "Shulker in offhand automatisch befüllen";
    }

    @Override
    protected String description() {
        return "Wenn eine Shulker in der zweiten Hand gehalten wird, werden alle aufgesammelten Items in dieser abgelegt";
    }

    @Override
    protected Material icon() {
        return Material.SHULKER_BOX;
    }

    @Override
    protected Options.Option defaultValue() {
        return disabled;
    }

    @Override
    public SettingCategory category() {
        return SettingCategory.Gameplay;
    }
}
