package eu.mhsl.craftattack.spawn.appliances.chatMessages;

import eu.mhsl.craftattack.spawn.appliance.ApplianceListener;
import eu.mhsl.craftattack.spawn.appliances.settings.Settings;
import eu.mhsl.craftattack.spawn.util.IteratorUtil;
import io.papermc.paper.event.player.AsyncChatEvent;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.text.format.TextColor;
import org.bukkit.Color;
import org.bukkit.event.EventHandler;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;

import java.util.Optional;

public class ChatMessagesListener extends ApplianceListener<ChatMessages> {
    @EventHandler
    public void onPlayerChatEvent(AsyncChatEvent event) {
        event.renderer(
            (source, sourceDisplayName, message, viewer) ->
                Component.text("")
                    .append(getAppliance().getReportablePlayerName(source))
                    .append(Component.text(" > ").color(TextColor.color(Color.GRAY.asRGB())))
                    .append(message).color(TextColor.color(Color.SILVER.asRGB()))
        );
    }

    @EventHandler
    public void onPlayerJoin(PlayerJoinEvent event) {
        event.joinMessage(null);
        IteratorUtil.onlinePlayers(player -> {
            if(!Settings.instance().getSetting(player, Settings.Key.ShowJoinAndLeaveMessages, Boolean.class)) return;
            player.sendMessage(
                Component
                    .text(">>> ").color(NamedTextColor.GREEN)
                    .append(getAppliance().getReportablePlayerName(event.getPlayer()))
            );
        });
    }

    @EventHandler
    public void onPlayerLeave(PlayerQuitEvent event) {
        event.quitMessage(null);
        IteratorUtil.onlinePlayers(player -> {
            if(!Settings.instance().getSetting(player, Settings.Key.ShowJoinAndLeaveMessages, Boolean.class)) return;
            player.sendMessage(
                Component
                    .text("<<< ").color(NamedTextColor.RED)
                    .append(getAppliance().getReportablePlayerName(event.getPlayer()))
            );
        });
    }

    @EventHandler
    public void onDeath(PlayerDeathEvent event) {
        event.deathMessage(
            Component
                .text("☠ ")
                .append(
                    Optional
                        .ofNullable(event.deathMessage())
                        .orElse(Component.text(event.getPlayer().getName()))
                )
                .color(TextColor.color(Color.SILVER.asRGB()))
        );
    }
}
