package eu.mhsl.craftattack.spawn.appliances.displayName;

import eu.mhsl.craftattack.spawn.Main;
import eu.mhsl.craftattack.spawn.appliance.Appliance;
import eu.mhsl.craftattack.spawn.appliances.adminMarker.AdminMarker;
import eu.mhsl.craftattack.spawn.appliances.adminMarker.AdminMarkerListener;
import eu.mhsl.craftattack.spawn.appliances.outlawed.Outlawed;
import eu.mhsl.craftattack.spawn.appliances.yearRank.YearRank;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.ComponentBuilder;
import net.kyori.adventure.text.TextComponent;
import net.kyori.adventure.text.format.TextColor;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.jetbrains.annotations.NotNull;

import java.util.List;
import java.util.function.Supplier;
import java.util.logging.Level;

public class DisplayName extends Appliance {
    public void update(Player player) {
        TextColor playerColor = queryAppliance(AdminMarker.class).getPlayerColor(player);
        List<Supplier<Component>> prefixes = List.of(
            () -> queryAppliance(Outlawed.class).getNamePrefix(player),
            () -> queryAppliance(YearRank.class).getNamePrefix(player)
        );

        ComponentBuilder<TextComponent, TextComponent.Builder> playerName = Component.text();
        prefixes.forEach(supplier -> {
            Component prefix = supplier.get();
            if(prefix == null) return;
            playerName.append(prefix).append(
                Component.text(" ").hoverEvent(Component.empty().asHoverEvent()));
        });

        playerName.append(Component.text(player.getName(), playerColor));

        setGlobal(player, playerName.build());
    }

    private void setGlobal(Player player, Component component) {
        try {
            player.customName(component);
            player.displayName(component);
            player.playerListName(component);
        } catch(Exception e) {
            //TODO this throws often exceptions, but still works, don't know why
            Main.instance().getLogger().log(Level.SEVERE, e, e::getMessage);
        }
    }


    @Override
    @NotNull
    protected List<Listener> listeners() {
        return List.of(new AdminMarkerListener());
    }
}
