package eu.mhsl.craftattack.spawn.appliances.doubeDoor;

import eu.mhsl.craftattack.spawn.appliance.ApplianceListener;
import eu.mhsl.craftattack.spawn.appliances.settings.Settings;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.event.EventHandler;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.EquipmentSlot;

import java.util.Objects;

public class OnDoorInteractListener extends ApplianceListener<DoubleDoor> {
    @EventHandler
    public void onPlayerInteract(PlayerInteractEvent event) {
        if(!event.hasBlock()) return;
        if(!Objects.equals(event.getHand(), EquipmentSlot.HAND)) return;
        if(!event.getAction().equals(Action.RIGHT_CLICK_BLOCK)) return;
        if(event.getPlayer().isSneaking()) return;
        Block clickedBlock = event.getClickedBlock();
        if(clickedBlock == null) return;
        if(clickedBlock.getType().equals(Material.IRON_DOOR)) return;
        if(!Settings.instance().getSetting(event.getPlayer(), Settings.Key.DoubleDoors, Boolean.class)) return;
        getAppliance().openNextDoor(clickedBlock);
    }
}
