package eu.mhsl.craftattack.spawn.appliances.knockDoor;

import eu.mhsl.craftattack.spawn.appliances.settings.CategorizedSetting;
import eu.mhsl.craftattack.spawn.appliances.settings.SettingCategory;
import eu.mhsl.craftattack.spawn.appliances.settings.Settings;
import eu.mhsl.craftattack.spawn.appliances.settings.datatypes.SelectSetting;
import org.bukkit.Material;
import org.bukkit.NamespacedKey;

import java.util.List;
import java.util.Locale;

public class KnockDoorSetting extends SelectSetting implements CategorizedSetting {
    private static final String namespace = KnockDoorSetting.class.getSimpleName().toLowerCase(Locale.ROOT);
    public static Options.Option disabled = new Options.Option("Deaktiviert", new NamespacedKey(namespace, "disabled"));
    public static Options.Option knockSingleTime = new Options.Option("Einmal an der Tür anklopfen", new NamespacedKey(namespace, "single"));
    public static Options.Option knockThreeTimes = new Options.Option("Dreimal an der Tür anklopfen", new NamespacedKey(namespace, "three"));

    public KnockDoorSetting() {
        super(
            Settings.Key.KnockDoors,
            new Options(List.of(disabled, knockSingleTime, knockThreeTimes))
        );
    }

    @Override
    public SettingCategory category() {
        return SettingCategory.Gameplay;
    }

    @Override
    protected String title() {
        return "Klopfen an Türen";
    }

    @Override
    protected String description() {
        return "Klopft durch das schlagen an eine Tür an.";
    }

    @Override
    protected Material icon() {
        return Material.BELL;
    }

    @Override
    protected Options.Option defaultValue() {
        return disabled;
    }
}
