package eu.mhsl.craftattack.spawn.appliances.maintenance;

import eu.mhsl.craftattack.spawn.appliance.Appliance;
import eu.mhsl.craftattack.spawn.appliance.ApplianceCommand;
import eu.mhsl.craftattack.spawn.config.Configuration;
import org.bukkit.event.Listener;
import org.jetbrains.annotations.NotNull;

import java.util.List;

public class Maintenance extends Appliance {
    private boolean isInMaintenance;
    private final String configKey = "enabled";

    public Maintenance() {
        super("maintenance");
    }

    @Override
    public void onEnable() {
        this.isInMaintenance = localConfig().getBoolean(configKey, false);
    }

    public void setState(boolean enabled) {
        this.isInMaintenance = enabled;
        localConfig().set(configKey, enabled);
        Configuration.saveChanges();
    }

    public boolean isInMaintenance() {
        return isInMaintenance;
    }

    @Override
    protected @NotNull List<ApplianceCommand<?>> commands() {
        return List.of(new MaintenanceCommand());
    }

    @Override
    protected @NotNull List<Listener> listeners() {
        return List.of(new PreventMaintenanceJoinListener());
    }
}
