package eu.mhsl.craftattack.spawn.appliances.maintenance;

import eu.mhsl.craftattack.spawn.appliance.ApplianceCommand;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;
import java.util.Map;

public class MaintenanceCommand extends ApplianceCommand<Maintenance> {
    Map<String, Boolean> arguments = Map.of("enable", true, "disable", false);

    public MaintenanceCommand() {
        super("maintanance");
    }

    @Override
    protected void execute(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) throws Exception {
        if(args.length != 1 || !arguments.containsKey(args[0])) throw new Error("Argument 'enable' oder 'disable' gefordert!");
        getAppliance().setState(arguments.get(args[0]));
        sender.sendMessage(String.format("Maintanance: %b", getAppliance().isInMaintenance()));
    }

    @Override
    public @Nullable List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        return arguments.keySet().stream().toList();
    }
}
