package eu.mhsl.craftattack.spawn.appliances.panicBan;

import eu.mhsl.craftattack.spawn.appliance.Appliance;
import eu.mhsl.craftattack.spawn.appliance.ApplianceCommand;
import eu.mhsl.craftattack.spawn.util.text.DisconnectInfo;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.jetbrains.annotations.NotNull;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;

public class PanicBan extends Appliance {
    private final Map<UUID, Long> panicBans = new HashMap<>();

    public void panicBan(@NotNull String playerName) {
        Player player = Bukkit.getPlayer(playerName);

        if(player == null)
            throw new ApplianceCommand.Error("Player not found");

        panicBans.put(player.getUniqueId(), System.currentTimeMillis());
        this.getDisconnectInfo(player.getUniqueId()).applyKick(player);
    }

    public boolean isBanned(UUID player) {
        if(panicBans.containsKey(player) && panicBans.get(player) < System.currentTimeMillis() - 15 * 60 * 1000)
            panicBans.remove(player);

        return panicBans.containsKey(player);
    }

    public DisconnectInfo getDisconnectInfo(UUID playerUuid) {
        return new DisconnectInfo(
            "Temporäre Sperre",
            "Du wurdest von einen Admin vom Server geworfen!",
            "Du bist bis zur endgültigen Klärung gesperrt.",
            playerUuid
        );
    }

    @Override
    @NotNull
    protected List<ApplianceCommand<?>> commands() {
        return List.of(new PanicBanCommand());
    }

    @Override
    @NotNull
    protected List<Listener> listeners() {
        return List.of(new PanicBanJoinListener());
    }
}
