package eu.mhsl.craftattack.spawn.appliances.settings.datatypes;

import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.persistence.PersistentDataContainer;


public abstract class ActionSetting extends Setting<Void> {
    public ActionSetting() {
        super(null);
    }

    protected abstract void onAction(Player player, ClickType clickType);

    @Override
    public ItemMeta buildMeta(ItemMeta meta) {
        meta.displayName(Component.text(title(), NamedTextColor.WHITE));
        meta.lore(buildDescription(description()));
        return meta;
    }

    @Override
    protected void change(Player player, ClickType clickType) {
        onAction(player, clickType);
    }

    @Override
    protected Void defaultValue() {
        return null;
    }

    @Override
    protected void fromStorage(PersistentDataContainer container) {}

    @Override
    protected void toStorage(PersistentDataContainer container, Void value) {}

    @Override
    public Class<?> dataType() {
        return null;
    }

    @Override
    public Void state() {
        return null;
    }
}
