package eu.mhsl.craftattack.spawn.util.text;

import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.TextColor;

import java.awt.*;

public class RainbowComponent {
    private float hueOffset = 0;
    private final String text;
    private final int density;
    private final float speed;

    public RainbowComponent(String text, int density, float speed) {
        this.text = text;
        this.density = density;
        this.speed = speed;
    }

    public Component getRainbowState() {
        Component builder = Component.empty();
        float hue = this.hueOffset;
        for (char c : text.toCharArray()) {
            float normalizedHue = (hue % 360) / 360;
            TextColor color = TextColor.color(Color.getHSBColor(normalizedHue, 1, 1).getRGB());
            builder = builder.append(Component.text(c).color(color));
            hue += density;
        }

        this.hueOffset = (this.hueOffset + speed) % 360;

        return builder;
    }
}