package eu.mhsl.craftattack.spawn.util.world;

import net.kyori.adventure.key.Key;
import net.kyori.adventure.sound.Sound;
import org.bukkit.entity.Player;

public class InteractSounds {
    private final Player player;

    public static InteractSounds of(Player player) {
        return new InteractSounds(player);
    }

    private InteractSounds(Player player) {
        this.player = player;
    }

    private void playSound(org.bukkit.Sound sound) {
        player.playSound(getSound(sound.key()), Sound.Emitter.self());
    }

    private Sound getSound(Key soundKey) {
        return Sound.sound(soundKey, Sound.Source.PLAYER, 1f, 1f);
    }

    public void click() {
        playSound(org.bukkit.Sound.UI_BUTTON_CLICK);
    }

    public void success() {
        playSound(org.bukkit.Sound.ENTITY_PLAYER_LEVELUP);
    }

    public void delete() {
        playSound(org.bukkit.Sound.ENTITY_SILVERFISH_DEATH);
    }
}
